diff --git a/doc/guides/nics/features/nfp.ini b/doc/guides/nics/features/nfp.ini
index 16fdf87..68f5b89 100644
--- a/doc/guides/nics/features/nfp.ini
+++ b/doc/guides/nics/features/nfp.ini
@@ -52,3 +52,4 @@ set_ipv6_dst         = Y
 set_ipv6_src         = Y
 set_mac_dst          = Y
 set_mac_src          = Y
+set_tp_src           = Y
diff --git a/drivers/net/nfp/flower/nfp_flower_cmsg.h b/drivers/net/nfp/flower/nfp_flower_cmsg.h
index 45e50dd..26de8b1 100644
--- a/drivers/net/nfp/flower/nfp_flower_cmsg.h
+++ b/drivers/net/nfp/flower/nfp_flower_cmsg.h
@@ -432,6 +432,27 @@ struct nfp_fl_act_set_ipv6_addr {
 	} ipv6[4];
 };
 
+/*
+ * TCP/UDP/SCTP
+ *    3                   2                   1
+ *  1 0 9 8 7 6 5 4 3 2 1 0 9 8 7 6 5 4 3 2 1 0 9 8 7 6 5 4 3 2 1 0
+ * +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
+ * |   -   |opcode |       |jump_id|               -               |
+ * +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
+ * |          src_mask             |         dst_mask              |
+ * +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
+ * |          src                  |         dst                   |
+ * +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
+ */
+struct nfp_fl_act_set_tport {
+	struct nfp_fl_act_head head;
+	rte_be16_t reserved;
+	rte_be16_t src_port_mask;
+	rte_be16_t dst_port_mask;
+	rte_be16_t src_port;
+	rte_be16_t dst_port;
+};
+
 int nfp_flower_cmsg_mac_repr(struct nfp_app_fw_flower *app_fw_flower);
 int nfp_flower_cmsg_repr_reify(struct nfp_app_fw_flower *app_fw_flower,
 		struct nfp_flower_representor *repr);
diff --git a/drivers/net/nfp/nfp_flow.c b/drivers/net/nfp/nfp_flow.c
index 6c53fba..96bb69d 100644
--- a/drivers/net/nfp/nfp_flow.c
+++ b/drivers/net/nfp/nfp_flow.c
@@ -575,6 +575,7 @@ struct nfp_mask_id_entry {
 	int ret = 0;
 	bool mac_set_flag = false;
 	bool ip_set_flag = false;
+	bool tp_set_flag = false;
 	const struct rte_flow_action *action;
 
 	for (action = actions; action->type != RTE_FLOW_ACTION_TYPE_END; ++action) {
@@ -657,6 +658,13 @@ struct nfp_mask_id_entry {
 			PMD_DRV_LOG(DEBUG, "RTE_FLOW_ACTION_TYPE_SET_IPV6_DST detected");
 			key_ls->act_size += sizeof(struct nfp_fl_act_set_ipv6_addr);
 			break;
+		case RTE_FLOW_ACTION_TYPE_SET_TP_SRC:
+			PMD_DRV_LOG(DEBUG, "RTE_FLOW_ACTION_TYPE_SET_TP_SRC detected");
+			if (!tp_set_flag) {
+				key_ls->act_size += sizeof(struct nfp_fl_act_set_tport);
+				tp_set_flag = true;
+			}
+			break;
 		default:
 			PMD_DRV_LOG(ERR, "Action type %d not supported.", action->type);
 			return -ENOTSUP;
@@ -1374,6 +1382,33 @@ struct nfp_mask_id_entry {
 		set_ip->ipv6[i].exact = set_ipv6->ipv6_addr[i];
 }
 
+static void
+nfp_flow_action_set_tp(char *act_data,
+		const struct rte_flow_action *action,
+		bool tp_src_flag,
+		bool tp_set_flag)
+{
+	size_t act_size;
+	struct nfp_fl_act_set_tport *set_tp;
+	const struct rte_flow_action_set_tp *set_tp_conf;
+
+	if (tp_set_flag)
+		set_tp = (struct nfp_fl_act_set_tport *)act_data - 1;
+	else
+		set_tp = (struct nfp_fl_act_set_tport *)act_data;
+
+	act_size = sizeof(struct nfp_fl_act_set_tport);
+	set_tp->head.jump_id = NFP_FL_ACTION_OPCODE_SET_TCP;
+	set_tp->head.len_lw  = act_size >> NFP_FL_LW_SIZ;
+	set_tp->reserved     = 0;
+
+	set_tp_conf = (const struct rte_flow_action_set_tp *)action->conf;
+	if (tp_src_flag)
+		set_tp->src_port = set_tp_conf->port;
+	else
+		set_tp->dst_port = set_tp_conf->port;
+}
+
 static int
 nfp_flow_action_push_vlan(char *act_data,
 		const struct rte_flow_action *action)
@@ -1417,6 +1452,7 @@ struct nfp_mask_id_entry {
 	char *action_data;
 	bool drop_flag = false;
 	bool ip_set_flag = false;
+	bool tp_set_flag = false;
 	bool mac_set_flag = false;
 	uint32_t total_actions = 0;
 	const struct rte_flow_action *action;
@@ -1518,6 +1554,14 @@ struct nfp_mask_id_entry {
 			nfp_flow_action_set_ipv6(position, action, false);
 			position += sizeof(struct nfp_fl_act_set_ipv6_addr);
 			break;
+		case RTE_FLOW_ACTION_TYPE_SET_TP_SRC:
+			PMD_DRV_LOG(DEBUG, "Process RTE_FLOW_ACTION_TYPE_SET_TP_SRC");
+			nfp_flow_action_set_tp(position, action, true, tp_set_flag);
+			if (!tp_set_flag) {
+				position += sizeof(struct nfp_fl_act_set_tport);
+				tp_set_flag = true;
+			}
+			break;
 		default:
 			PMD_DRV_LOG(ERR, "Unsupported action type: %d", action->type);
 			return -ENOTSUP;