diff --git a/doc/guides/nics/features/nfp.ini b/doc/guides/nics/features/nfp.ini
index d4ceae0..9dff34b 100644
--- a/doc/guides/nics/features/nfp.ini
+++ b/doc/guides/nics/features/nfp.ini
@@ -29,6 +29,8 @@ Usage doc            = Y
 [rte_flow items]
 eth                  = Y
 ipv4                 = Y
+ipv6                 = Y
+ipv6_frag_ext        = Y
 port_id              = Y
 vlan                 = Y
 
diff --git a/doc/guides/rel_notes/release_22_11.rst b/doc/guides/rel_notes/release_22_11.rst
index 5eb40df..e794e11 100644
--- a/doc/guides/rel_notes/release_22_11.rst
+++ b/doc/guides/rel_notes/release_22_11.rst
@@ -110,6 +110,7 @@ New Features
     * Ethernet
     * Single VLAN
     * IPv4
+    * IPv6
 
   Add the support of rte_flow actions as follow:
 
diff --git a/drivers/net/nfp/flower/nfp_flower_cmsg.h b/drivers/net/nfp/flower/nfp_flower_cmsg.h
index 5964ecf..36d406f 100644
--- a/drivers/net/nfp/flower/nfp_flower_cmsg.h
+++ b/drivers/net/nfp/flower/nfp_flower_cmsg.h
@@ -291,6 +291,39 @@ struct nfp_flower_ipv4 {
 	rte_be32_t ipv4_dst;
 };
 
+/*
+ * L3 IPv6 details (10W/40B)
+ *    3                   2                   1
+ *  1 0 9 8 7 6 5 4 3 2 1 0 9 8 7 6 5 4 3 2 1 0 9 8 7 6 5 4 3 2 1 0
+ * +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
+ * |    DSCP   |ECN|   protocol    |      ttl      |     flags     |
+ * +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
+ * |   ipv6_exthdr   | res |            ipv6_flow_label            |
+ * +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
+ * |                  ipv6_addr_src,   31 - 0                      |
+ * +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
+ * |                  ipv6_addr_src,  63 - 32                      |
+ * +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
+ * |                  ipv6_addr_src,  95 - 64                      |
+ * +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
+ * |                  ipv6_addr_src, 127 - 96                      |
+ * +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
+ * |                  ipv6_addr_dst,   31 - 0                      |
+ * +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
+ * |                  ipv6_addr_dst,  63 - 32                      |
+ * +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
+ * |                  ipv6_addr_dst,  95 - 64                      |
+ * +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
+ * |                  ipv6_addr_dst, 127 - 96                      |
+ * +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
+ */
+struct nfp_flower_ipv6 {
+	struct nfp_flower_ip_ext ip_ext;
+	rte_be32_t ipv6_flow_label_exthdr;
+	uint8_t ipv6_src[16];
+	uint8_t ipv6_dst[16];
+};
+
 struct nfp_fl_act_head {
 	uint8_t jump_id;
 	uint8_t len_lw;
diff --git a/drivers/net/nfp/nfp_flow.c b/drivers/net/nfp/nfp_flow.c
index 810f2d7..5b78110 100644
--- a/drivers/net/nfp/nfp_flow.c
+++ b/drivers/net/nfp/nfp_flow.c
@@ -539,6 +539,11 @@ struct nfp_mask_id_entry {
 			key_ls->key_layer |= NFP_FLOWER_LAYER_IPV4;
 			key_ls->key_size += sizeof(struct nfp_flower_ipv4);
 			break;
+		case RTE_FLOW_ITEM_TYPE_IPV6:
+			PMD_DRV_LOG(DEBUG, "RTE_FLOW_ITEM_TYPE_IPV6 detected");
+			key_ls->key_layer |= NFP_FLOWER_LAYER_IPV6;
+			key_ls->key_size += sizeof(struct nfp_flower_ipv6);
+			break;
 		default:
 			PMD_DRV_LOG(ERR, "Item type %d not supported.", item->type);
 			return -ENOTSUP;
@@ -723,6 +728,51 @@ struct nfp_mask_id_entry {
 	return 0;
 }
 
+static int
+nfp_flow_merge_ipv6(struct rte_flow *nfp_flow,
+		char **mbuf_off,
+		const struct rte_flow_item *item,
+		const struct nfp_flow_item_proc *proc,
+		bool is_mask)
+{
+	struct nfp_flower_ipv6 *ipv6;
+	const struct rte_ipv6_hdr *hdr;
+	struct nfp_flower_meta_tci *meta_tci;
+	const struct rte_flow_item_ipv6 *spec;
+	const struct rte_flow_item_ipv6 *mask;
+
+	spec = item->spec;
+	mask = item->mask ? item->mask : proc->mask_default;
+	meta_tci = (struct nfp_flower_meta_tci *)nfp_flow->payload.unmasked_data;
+
+	if (spec == NULL) {
+		PMD_DRV_LOG(DEBUG, "nfp flow merge ipv6: no item->spec!");
+		goto ipv6_end;
+	}
+
+	/*
+	 * reserve space for L4 info.
+	 * rte_flow has ipv4 before L4 but NFP flower fw requires L4 before ipv4
+	 */
+	if (meta_tci->nfp_flow_key_layer & NFP_FLOWER_LAYER_TP)
+		*mbuf_off += sizeof(struct nfp_flower_tp_ports);
+
+	hdr = is_mask ? &mask->hdr : &spec->hdr;
+	ipv6 = (struct nfp_flower_ipv6 *)*mbuf_off;
+
+	ipv6->ip_ext.tos   = (hdr->vtc_flow & RTE_IPV6_HDR_TC_MASK) >>
+			RTE_IPV6_HDR_TC_SHIFT;
+	ipv6->ip_ext.proto = hdr->proto;
+	ipv6->ip_ext.ttl   = hdr->hop_limits;
+	memcpy(ipv6->ipv6_src, hdr->src_addr, sizeof(ipv6->ipv6_src));
+	memcpy(ipv6->ipv6_dst, hdr->dst_addr, sizeof(ipv6->ipv6_dst));
+
+ipv6_end:
+	*mbuf_off += sizeof(struct nfp_flower_ipv6);
+
+	return 0;
+}
+
 /* Graph of supported items and associated process function */
 static const struct nfp_flow_item_proc nfp_flow_item_proc_list[] = {
 	[RTE_FLOW_ITEM_TYPE_END] = {
@@ -730,7 +780,8 @@ struct nfp_mask_id_entry {
 	},
 	[RTE_FLOW_ITEM_TYPE_ETH] = {
 		.next_item = NEXT_ITEM(RTE_FLOW_ITEM_TYPE_VLAN,
-			RTE_FLOW_ITEM_TYPE_IPV4),
+			RTE_FLOW_ITEM_TYPE_IPV4,
+			RTE_FLOW_ITEM_TYPE_IPV6),
 		.mask_support = &(const struct rte_flow_item_eth){
 			.hdr = {
 				.dst_addr.addr_bytes = "\xff\xff\xff\xff\xff\xff",
@@ -744,7 +795,8 @@ struct nfp_mask_id_entry {
 		.merge = nfp_flow_merge_eth,
 	},
 	[RTE_FLOW_ITEM_TYPE_VLAN] = {
-		.next_item = NEXT_ITEM(RTE_FLOW_ITEM_TYPE_IPV4),
+		.next_item = NEXT_ITEM(RTE_FLOW_ITEM_TYPE_IPV4,
+			RTE_FLOW_ITEM_TYPE_IPV6),
 		.mask_support = &(const struct rte_flow_item_vlan){
 			.hdr = {
 				.vlan_tci  = RTE_BE16(0xefff),
@@ -771,6 +823,23 @@ struct nfp_mask_id_entry {
 		.mask_sz = sizeof(struct rte_flow_item_ipv4),
 		.merge = nfp_flow_merge_ipv4,
 	},
+	[RTE_FLOW_ITEM_TYPE_IPV6] = {
+		.mask_support = &(const struct rte_flow_item_ipv6){
+			.hdr = {
+				.vtc_flow   = RTE_BE32(0x0ff00000),
+				.proto      = 0xff,
+				.hop_limits = 0xff,
+				.src_addr   = "\xff\xff\xff\xff\xff\xff\xff\xff"
+					"\xff\xff\xff\xff\xff\xff\xff\xff",
+				.dst_addr   = "\xff\xff\xff\xff\xff\xff\xff\xff"
+					"\xff\xff\xff\xff\xff\xff\xff\xff",
+			},
+			.has_frag_ext = 1,
+		},
+		.mask_default = &rte_flow_item_ipv6_mask,
+		.mask_sz = sizeof(struct rte_flow_item_ipv6),
+		.merge = nfp_flow_merge_ipv6,
+	},
 };
 
 static int