diff --git a/doc/guides/nics/features/nfp.ini b/doc/guides/nics/features/nfp.ini
index 514e0ba..8f7120b 100644
--- a/doc/guides/nics/features/nfp.ini
+++ b/doc/guides/nics/features/nfp.ini
@@ -46,5 +46,6 @@ of_push_vlan         = Y
 of_set_vlan_pcp      = Y
 of_set_vlan_vid      = Y
 port_id              = Y
+set_ipv4_src         = Y
 set_mac_dst          = Y
 set_mac_src          = Y
diff --git a/drivers/net/nfp/flower/nfp_flower_cmsg.h b/drivers/net/nfp/flower/nfp_flower_cmsg.h
index 30a9ff5..77cb51d 100644
--- a/drivers/net/nfp/flower/nfp_flower_cmsg.h
+++ b/drivers/net/nfp/flower/nfp_flower_cmsg.h
@@ -374,6 +374,31 @@ struct nfp_fl_act_push_vlan {
 	rte_be16_t vlan_tci;
 };
 
+/*
+ * IPv4 addrs
+ *    3                   2                   1
+ *  1 0 9 8 7 6 5 4 3 2 1 0 9 8 7 6 5 4 3 2 1 0 9 8 7 6 5 4 3 2 1 0
+ * +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
+ * |   -   |opcode |       |jump_id|               -               |
+ * +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
+ * |                     ipv4_saddr_mask                           |
+ * +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
+ * |                     ipv4_saddr                                |
+ * +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
+ * |                     ipv4_daddr_mask                           |
+ * +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
+ * |                     ipv4_daddr                                |
+ * +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
+ */
+struct nfp_fl_act_set_ip4_addrs {
+	struct nfp_fl_act_head head;
+	rte_be16_t reserved;
+	rte_be32_t ipv4_src_mask;
+	rte_be32_t ipv4_src;
+	rte_be32_t ipv4_dst_mask;
+	rte_be32_t ipv4_dst;
+};
+
 int nfp_flower_cmsg_mac_repr(struct nfp_app_fw_flower *app_fw_flower);
 int nfp_flower_cmsg_repr_reify(struct nfp_app_fw_flower *app_fw_flower,
 		struct nfp_flower_representor *repr);
diff --git a/drivers/net/nfp/nfp_flow.c b/drivers/net/nfp/nfp_flow.c
index d66bcca..54f94e5 100644
--- a/drivers/net/nfp/nfp_flow.c
+++ b/drivers/net/nfp/nfp_flow.c
@@ -574,6 +574,7 @@ struct nfp_mask_id_entry {
 {
 	int ret = 0;
 	bool mac_set_flag = false;
+	bool ip_set_flag = false;
 	const struct rte_flow_action *action;
 
 	for (action = actions; action->type != RTE_FLOW_ACTION_TYPE_END; ++action) {
@@ -632,6 +633,14 @@ struct nfp_mask_id_entry {
 		case RTE_FLOW_ACTION_TYPE_OF_SET_VLAN_PCP:
 			PMD_DRV_LOG(DEBUG, "RTE_FLOW_ACTION_TYPE_OF_SET_VLAN_PCP detected");
 			break;
+		case RTE_FLOW_ACTION_TYPE_SET_IPV4_SRC:
+			PMD_DRV_LOG(DEBUG, "RTE_FLOW_ACTION_TYPE_SET_IPV4_SRC detected");
+			if (!ip_set_flag) {
+				key_ls->act_size +=
+					sizeof(struct nfp_fl_act_set_ip4_addrs);
+				ip_set_flag = true;
+			}
+			break;
 		default:
 			PMD_DRV_LOG(ERR, "Action type %d not supported.", action->type);
 			return -ENOTSUP;
@@ -1296,6 +1305,33 @@ struct nfp_mask_id_entry {
 	nfp_flow_meta->shortcut = rte_cpu_to_be_32(NFP_FL_SC_ACT_POPV);
 }
 
+static void
+nfp_flow_action_set_ip(char *act_data,
+		const struct rte_flow_action *action,
+		bool ip_src_flag,
+		bool ip_set_flag)
+{
+	size_t act_size;
+	struct nfp_fl_act_set_ip4_addrs *set_ip;
+	const struct rte_flow_action_set_ipv4 *set_ipv4;
+
+	if (ip_set_flag)
+		set_ip = (struct nfp_fl_act_set_ip4_addrs *)act_data - 1;
+	else
+		set_ip = (struct nfp_fl_act_set_ip4_addrs *)act_data;
+
+	act_size = sizeof(struct nfp_fl_act_set_ip4_addrs);
+	set_ip->head.jump_id = NFP_FL_ACTION_OPCODE_SET_IPV4_ADDRS;
+	set_ip->head.len_lw  = act_size >> NFP_FL_LW_SIZ;
+	set_ip->reserved     = 0;
+
+	set_ipv4 = (const struct rte_flow_action_set_ipv4 *)action->conf;
+	if (ip_src_flag)
+		set_ip->ipv4_src = set_ipv4->ipv4_addr;
+	else
+		set_ip->ipv4_dst = set_ipv4->ipv4_addr;
+}
+
 static int
 nfp_flow_action_push_vlan(char *act_data,
 		const struct rte_flow_action *action)
@@ -1338,6 +1374,7 @@ struct nfp_mask_id_entry {
 	char *position;
 	char *action_data;
 	bool drop_flag = false;
+	bool ip_set_flag = false;
 	bool mac_set_flag = false;
 	uint32_t total_actions = 0;
 	const struct rte_flow_action *action;
@@ -1413,6 +1450,14 @@ struct nfp_mask_id_entry {
 			action += 2;
 			position += sizeof(struct nfp_fl_act_push_vlan);
 			break;
+		case RTE_FLOW_ACTION_TYPE_SET_IPV4_SRC:
+			PMD_DRV_LOG(DEBUG, "Process RTE_FLOW_ACTION_TYPE_SET_IPV4_SRC");
+			nfp_flow_action_set_ip(position, action, true, ip_set_flag);
+			if (!ip_set_flag) {
+				position += sizeof(struct nfp_fl_act_set_ip4_addrs);
+				ip_set_flag = true;
+			}
+			break;
 		default:
 			PMD_DRV_LOG(ERR, "Unsupported action type: %d", action->type);
 			return -ENOTSUP;