diff --git a/doc/guides/nics/features/nfp.ini b/doc/guides/nics/features/nfp.ini
index 14a9c18..0c04458 100644
--- a/doc/guides/nics/features/nfp.ini
+++ b/doc/guides/nics/features/nfp.ini
@@ -48,5 +48,6 @@ of_set_vlan_vid      = Y
 port_id              = Y
 set_ipv4_dst         = Y
 set_ipv4_src         = Y
+set_ipv6_src         = Y
 set_mac_dst          = Y
 set_mac_src          = Y
diff --git a/drivers/net/nfp/flower/nfp_flower_cmsg.h b/drivers/net/nfp/flower/nfp_flower_cmsg.h
index 77cb51d..45e50dd 100644
--- a/drivers/net/nfp/flower/nfp_flower_cmsg.h
+++ b/drivers/net/nfp/flower/nfp_flower_cmsg.h
@@ -399,6 +399,39 @@ struct nfp_fl_act_set_ip4_addrs {
 	rte_be32_t ipv4_dst;
 };
 
+/*
+ * IPv6 addr
+ *    3                   2                   1
+ *  1 0 9 8 7 6 5 4 3 2 1 0 9 8 7 6 5 4 3 2 1 0 9 8 7 6 5 4 3 2 1 0
+ * +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
+ * |   -   |opcode |       |jump_id|               -               |
+ * +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
+ * |                     ipv6_addr_127_96_mask                     |
+ * +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
+ * |                     ipv6_addr_127_96                          |
+ * +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
+ * |                     ipv6_addr_95_64_mask                      |
+ * +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
+ * |                     ipv6_addr_95_64                           |
+ * +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
+ * |                     ipv6_addr_63_32_mask                      |
+ * +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
+ * |                     ipv6_addr_63_32                           |
+ * +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
+ * |                     ipv6_addr_31_0_mask                       |
+ * +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
+ * |                     ipv6_addr_31_0                            |
+ * +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
+ */
+struct nfp_fl_act_set_ipv6_addr {
+	struct nfp_fl_act_head head;
+	rte_be16_t reserved;
+	struct {
+		rte_be32_t mask;
+		rte_be32_t exact;
+	} ipv6[4];
+};
+
 int nfp_flower_cmsg_mac_repr(struct nfp_app_fw_flower *app_fw_flower);
 int nfp_flower_cmsg_repr_reify(struct nfp_app_fw_flower *app_fw_flower,
 		struct nfp_flower_representor *repr);
diff --git a/drivers/net/nfp/nfp_flow.c b/drivers/net/nfp/nfp_flow.c
index aeaf1f4..1adc3dd 100644
--- a/drivers/net/nfp/nfp_flow.c
+++ b/drivers/net/nfp/nfp_flow.c
@@ -649,6 +649,10 @@ struct nfp_mask_id_entry {
 				ip_set_flag = true;
 			}
 			break;
+		case RTE_FLOW_ACTION_TYPE_SET_IPV6_SRC:
+			PMD_DRV_LOG(DEBUG, "RTE_FLOW_ACTION_TYPE_SET_IPV6_SRC detected");
+			key_ls->act_size += sizeof(struct nfp_fl_act_set_ipv6_addr);
+			break;
 		default:
 			PMD_DRV_LOG(ERR, "Action type %d not supported.", action->type);
 			return -ENOTSUP;
@@ -1340,6 +1344,32 @@ struct nfp_mask_id_entry {
 		set_ip->ipv4_dst = set_ipv4->ipv4_addr;
 }
 
+static void
+nfp_flow_action_set_ipv6(char *act_data,
+		const struct rte_flow_action *action,
+		bool ip_src_flag)
+{
+	int i;
+	size_t act_size;
+	struct nfp_fl_act_set_ipv6_addr *set_ip;
+	const struct rte_flow_action_set_ipv6 *set_ipv6;
+
+	set_ip = (struct nfp_fl_act_set_ipv6_addr *)act_data;
+	set_ipv6 = (const struct rte_flow_action_set_ipv6 *)action->conf;
+
+	if (ip_src_flag)
+		set_ip->head.jump_id = NFP_FL_ACTION_OPCODE_SET_IPV6_SRC;
+	else
+		set_ip->head.jump_id = NFP_FL_ACTION_OPCODE_SET_IPV6_DST;
+
+	act_size = sizeof(struct nfp_fl_act_set_ipv6_addr);
+	set_ip->head.len_lw = act_size >> NFP_FL_LW_SIZ;
+	set_ip->reserved = 0;
+
+	for (i = 0; i < 4; i++)
+		set_ip->ipv6[i].exact = set_ipv6->ipv6_addr[i];
+}
+
 static int
 nfp_flow_action_push_vlan(char *act_data,
 		const struct rte_flow_action *action)
@@ -1474,6 +1504,11 @@ struct nfp_mask_id_entry {
 				ip_set_flag = true;
 			}
 			break;
+		case RTE_FLOW_ACTION_TYPE_SET_IPV6_SRC:
+			PMD_DRV_LOG(DEBUG, "Process RTE_FLOW_ACTION_TYPE_SET_IPV6_SRC");
+			nfp_flow_action_set_ipv6(position, action, true);
+			position += sizeof(struct nfp_fl_act_set_ipv6_addr);
+			break;
 		default:
 			PMD_DRV_LOG(ERR, "Unsupported action type: %d", action->type);
 			return -ENOTSUP;