diff --git a/doc/guides/nics/features/nfp.ini b/doc/guides/nics/features/nfp.ini
index f0ecae2..d4ceae0 100644
--- a/doc/guides/nics/features/nfp.ini
+++ b/doc/guides/nics/features/nfp.ini
@@ -28,6 +28,7 @@ Usage doc            = Y
 
 [rte_flow items]
 eth                  = Y
+ipv4                 = Y
 port_id              = Y
 vlan                 = Y
 
diff --git a/doc/guides/rel_notes/release_22_11.rst b/doc/guides/rel_notes/release_22_11.rst
index fe6cf11..f6c0414 100644
--- a/doc/guides/rel_notes/release_22_11.rst
+++ b/doc/guides/rel_notes/release_22_11.rst
@@ -167,6 +167,7 @@ New Features
 
     * Ethernet
     * Single VLAN
+    * IPv4
 
   Add the support of rte_flow actions as follow:
 
diff --git a/drivers/net/nfp/flower/nfp_flower_cmsg.h b/drivers/net/nfp/flower/nfp_flower_cmsg.h
index d776e37..5964ecf 100644
--- a/drivers/net/nfp/flower/nfp_flower_cmsg.h
+++ b/drivers/net/nfp/flower/nfp_flower_cmsg.h
@@ -253,6 +253,44 @@ struct nfp_flower_mac_mpls {
 	rte_be32_t mpls_lse;
 };
 
+/*
+ * L4 ports (for UDP, TCP, SCTP) (1W/4B)
+ *    3                   2                   1
+ *  1 0 9 8 7 6 5 4 3 2 1 0 9 8 7 6 5 4 3 2 1 0 9 8 7 6 5 4 3 2 1 0
+ * +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
+ * |            port_src           |           port_dst            |
+ * +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
+ */
+struct nfp_flower_tp_ports {
+	rte_be16_t port_src;
+	rte_be16_t port_dst;
+};
+
+struct nfp_flower_ip_ext {
+	uint8_t tos;
+	uint8_t proto;
+	uint8_t ttl;
+	uint8_t flags;
+};
+
+/*
+ * L3 IPv4 details (3W/12B)
+ *    3                   2                   1
+ *  1 0 9 8 7 6 5 4 3 2 1 0 9 8 7 6 5 4 3 2 1 0 9 8 7 6 5 4 3 2 1 0
+ * +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
+ * |    DSCP   |ECN|   protocol    |      ttl      |     flags     |
+ * +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
+ * |                        ipv4_addr_src                          |
+ * +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
+ * |                        ipv4_addr_dst                          |
+ * +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
+ */
+struct nfp_flower_ipv4 {
+	struct nfp_flower_ip_ext ip_ext;
+	rte_be32_t ipv4_src;
+	rte_be32_t ipv4_dst;
+};
+
 struct nfp_fl_act_head {
 	uint8_t jump_id;
 	uint8_t len_lw;
diff --git a/drivers/net/nfp/nfp_flow.c b/drivers/net/nfp/nfp_flow.c
index 361fee2..b8280a6 100644
--- a/drivers/net/nfp/nfp_flow.c
+++ b/drivers/net/nfp/nfp_flow.c
@@ -534,6 +534,11 @@ struct nfp_mask_id_entry {
 			PMD_DRV_LOG(DEBUG, "RTE_FLOW_ITEM_TYPE_VLAN detected");
 			key_ls->vlan = NFP_FLOWER_MASK_VLAN_CFI;
 			break;
+		case RTE_FLOW_ITEM_TYPE_IPV4:
+			PMD_DRV_LOG(DEBUG, "RTE_FLOW_ITEM_TYPE_IPV4 detected");
+			key_ls->key_layer |= NFP_FLOWER_LAYER_IPV4;
+			key_ls->key_size += sizeof(struct nfp_flower_ipv4);
+			break;
 		default:
 			PMD_DRV_LOG(ERR, "Item type %d not supported.", item->type);
 			return -ENOTSUP;
@@ -674,13 +679,58 @@ struct nfp_mask_id_entry {
 	return 0;
 }
 
+static int
+nfp_flow_merge_ipv4(struct rte_flow *nfp_flow,
+		char **mbuf_off,
+		const struct rte_flow_item *item,
+		const struct nfp_flow_item_proc *proc,
+		bool is_mask)
+{
+	struct nfp_flower_ipv4 *ipv4;
+	const struct rte_ipv4_hdr *hdr;
+	struct nfp_flower_meta_tci *meta_tci;
+	const struct rte_flow_item_ipv4 *spec;
+	const struct rte_flow_item_ipv4 *mask;
+
+	spec = item->spec;
+	mask = item->mask ? item->mask : proc->mask_default;
+	meta_tci = (struct nfp_flower_meta_tci *)nfp_flow->payload.unmasked_data;
+
+	if (spec == NULL) {
+		PMD_DRV_LOG(DEBUG, "nfp flow merge ipv4: no item->spec!");
+		goto ipv4_end;
+	}
+
+	/*
+	 * reserve space for L4 info.
+	 * rte_flow has ipv4 before L4 but NFP flower fw requires L4 before ipv4
+	 */
+	if (meta_tci->nfp_flow_key_layer & NFP_FLOWER_LAYER_TP)
+		*mbuf_off += sizeof(struct nfp_flower_tp_ports);
+
+	hdr = is_mask ? &mask->hdr : &spec->hdr;
+	ipv4 = (struct nfp_flower_ipv4 *)*mbuf_off;
+
+	ipv4->ip_ext.tos   = hdr->type_of_service;
+	ipv4->ip_ext.proto = hdr->next_proto_id;
+	ipv4->ip_ext.ttl   = hdr->time_to_live;
+	ipv4->ipv4_src     = hdr->src_addr;
+	ipv4->ipv4_dst     = hdr->dst_addr;
+
+ipv4_end:
+	*mbuf_off += sizeof(struct nfp_flower_ipv4);
+
+	return 0;
+}
+
 /* Graph of supported items and associated process function */
 static const struct nfp_flow_item_proc nfp_flow_item_proc_list[] = {
 	[RTE_FLOW_ITEM_TYPE_END] = {
 		.next_item = NEXT_ITEM(RTE_FLOW_ITEM_TYPE_ETH),
 	},
 	[RTE_FLOW_ITEM_TYPE_ETH] = {
-		.next_item = NEXT_ITEM(RTE_FLOW_ITEM_TYPE_VLAN),
+		.next_item = NEXT_ITEM(RTE_FLOW_ITEM_TYPE_VLAN,
+			RTE_FLOW_ITEM_TYPE_IPV4),
 		.mask_support = &(const struct rte_flow_item_eth){
 			.hdr = {
 				.dst_addr.addr_bytes = "\xff\xff\xff\xff\xff\xff",
@@ -694,6 +744,7 @@ struct nfp_mask_id_entry {
 		.merge = nfp_flow_merge_eth,
 	},
 	[RTE_FLOW_ITEM_TYPE_VLAN] = {
+		.next_item = NEXT_ITEM(RTE_FLOW_ITEM_TYPE_IPV4),
 		.mask_support = &(const struct rte_flow_item_vlan){
 			.hdr = {
 				.vlan_tci  = RTE_BE16(0xefff),
@@ -705,6 +756,21 @@ struct nfp_mask_id_entry {
 		.mask_sz = sizeof(struct rte_flow_item_vlan),
 		.merge = nfp_flow_merge_vlan,
 	},
+	[RTE_FLOW_ITEM_TYPE_IPV4] = {
+		.mask_support = &(const struct rte_flow_item_ipv4){
+			.hdr = {
+				.type_of_service = 0xff,
+				.fragment_offset = RTE_BE16(0xffff),
+				.time_to_live    = 0xff,
+				.next_proto_id   = 0xff,
+				.src_addr        = RTE_BE32(0xffffffff),
+				.dst_addr        = RTE_BE32(0xffffffff),
+			},
+		},
+		.mask_default = &rte_flow_item_ipv4_mask,
+		.mask_sz = sizeof(struct rte_flow_item_ipv4),
+		.merge = nfp_flow_merge_ipv4,
+	},
 };
 
 static int